package ExtensionAlgorithm;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.net.URI;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

import org.semanticweb.owl.apibinding.OWLManager;
import org.semanticweb.owl.io.OWLXMLOntologyFormat;
import org.semanticweb.owl.model.AddAxiom;
import org.semanticweb.owl.model.OWLAxiom;
import org.semanticweb.owl.model.OWLClass;
import org.semanticweb.owl.model.OWLDataFactory;
import org.semanticweb.owl.model.OWLDescription;
import org.semanticweb.owl.model.OWLDescriptionVisitor;
import org.semanticweb.owl.model.OWLEntity;
import org.semanticweb.owl.model.OWLFunctionalObjectPropertyAxiom;
import org.semanticweb.owl.model.OWLObjectProperty;
import org.semanticweb.owl.model.OWLObjectPropertyExpression;
import org.semanticweb.owl.model.OWLObjectPropertyRangeAxiom;
import org.semanticweb.owl.model.OWLObjectSomeRestriction;
import org.semanticweb.owl.model.OWLObjectSubPropertyAxiom;
import org.semanticweb.owl.model.OWLOntology;
import org.semanticweb.owl.model.OWLOntologyChangeException;
import org.semanticweb.owl.model.OWLOntologyCreationException;
import org.semanticweb.owl.model.OWLOntologyManager;
import org.semanticweb.owl.model.OWLOntologyStorageException;
import org.semanticweb.owl.model.OWLPropertyExpression;
import org.semanticweb.owl.model.OWLPropertyExpressionVisitor;
import org.semanticweb.owl.model.OWLSubClassAxiom;
import org.semanticweb.owl.util.OWLEntityRemover;
import org.semanticweb.owl.vocab.OWLRDFVocabulary;




/**
 * @author Eleni Mikroyannidi
 * ExtendAlg_v0.4
 * Last modified:
 * Monday 8/6/08
 * 
 * Description:
 * Reverse method of the abstraction
 * Takes as input the abstracted ontology and creates the extended version
 * 
 * Initially:
 * Create all the sibling entities 
 * IT WORKS with restrictions as well!!!
 *
 */

public class Extend {
	OWLOntologyManager manager;
	OWLOntology ontology;
	URI classURI = null;
	URI physicalURI;
	OWLClass standard_fma;
	public String[] targets;
	
//Variables for the definition of the Refining_entity hierarchy	
	OWLDataFactory factory;
	OWLClass Refining_entity=null;
	OWLClass Selector=null;
	OWLObjectProperty hasSelector=null;
	OWLDescription hasSomeSymmetry=null;
	
	
	OWLClass Symmetry=null;
	
	//Variables for the abstraction of the entities
//	static Set<OWLClass> markedClasses = new HashSet<OWLClass>();
//	Set<OWLClass> abstractedEntities = new HashSet<OWLClass>();
//	static Set<OWLAxiom> remainedAxioms = new HashSet<OWLAxiom>();
//	static Set<OWLClass> abstractedClasses = new HashSet<OWLClass>();
//	static Set<OWLClass> addedClasses = new HashSet<OWLClass>();
//	static Set<OWLClass> symmetryClasses = new HashSet<OWLClass>();
	Set<OWLClass> cls_remove_restr = new HashSet<OWLClass>();
	
	Set<OWLClass> unequalEntities = new HashSet<OWLClass>();
	
	//Arguments:
	String ontologyFilename;
	String hierarchyFilename;
	String outputFolderName;
	 
	public Extend(String ontFilename, String hierFilename) throws OWLOntologyCreationException {
		
		//this.ontologyFilename = "file:/" + ontFilename.replace('\\', '/');
		//MacOS paths
		this.ontologyFilename = "file:" + ontFilename;     //replace("./", "");
		this.hierarchyFilename = hierFilename;
		
		//macOS paths
		this.outputFolderName = ontFilename.substring(0, ontFilename.lastIndexOf('/') - 1);
		//this.outputFolderName = ontFilename.substring(0, ontFilename.lastIndexOf('\\') + 1);
		System.out.println(outputFolderName);
		
	//	this.targets = targets;
		
		ArrayList<String> newTargets = new ArrayList<String>();
		
		try{
			FileInputStream target_file = new FileInputStream(hierarchyFilename);
        	BufferedReader buffered_file = new BufferedReader(new InputStreamReader(target_file));
        	String line;
        	
        	while((line = buffered_file.readLine()) != null) {
                //String trimmedLine = line.trim();
                newTargets.add(line);
                System.out.println(line);
            }
        	 target_file.close();
		}
		catch(Exception e){
        	   System.out.println("File input error");
		}
        
		targets = newTargets.toArray(new String[newTargets.size()]);
        for(int i=0; i<targets.length; i++){
             System.out.println(targets[i]);
        }

        //load ontology
        manager = OWLManager.createOWLOntologyManager();
        URI physicalURI = URI.create(ontologyFilename);
        ontology = manager.loadOntologyFromPhysicalURI(physicalURI);
        
        // Report information about the ontology
        System.out.println("Ontology Loaded...");
        System.out.println("Physical URI: " + physicalURI);
        System.out.println("Logical URI : " + ontology.getURI());
        System.out.println("Format      : " + manager.getOntologyFormat(ontology));
        
        if (classURI==null) {
            classURI = OWLRDFVocabulary.OWL_THING.getURI();
        }
        
        System.out.println("Class       : " + classURI);
        factory = manager.getOWLDataFactory();
    }
	
	public void doTheExtension(String ontologyFilename) throws OWLOntologyChangeException{
		int tab;
		int i=0;
		OWLClass Parent;
		String replace_str;
		OWLClass search_cls;
		OWLClass replace_cls;
		//OWLClass Child;
		Parent=Selector;
		
		
		OWLClass[] key_words= new OWLClass[targets.length];
		
		//for the abstraction
		 //OWLClass parent_cls = null;
		 
		 //OWLDescription hasSomeSymmetry=null;
		 //OWLEntityRemover remover = null;
		 
		
		while(i<targets.length){
			tab=targets[i].lastIndexOf("\t");
			int limit=0;
		   	if(tab==-1){
		   	   for(OWLClass c: ontology.getReferencedClasses()){
		   		   if(c.toString().equals(targets[i]))
		   			   Symmetry = c;
		   	   }
		   	   i++;
      	   }
      	   else {
      		   //Subclass 
      		   Set<OWLClass> markedClasses = new HashSet<OWLClass>();
//      		Set<OWLClass> abstractedEntities = new HashSet<OWLClass>();
      		   Set<OWLAxiom> remainedAxioms = new HashSet<OWLAxiom>();
      		   Set<OWLClass> abstractedClasses = new HashSet<OWLClass>();
      		   Set<OWLClass> addedClasses = new HashSet<OWLClass>();
      		   Set<OWLClass> symmetryClasses = new HashSet<OWLClass>();
      		   while(i<targets.length && (targets[i].lastIndexOf("\t"))!=-1){
      			   for(OWLClass child: ontology.getReferencedClasses()){
      				   if(child.toString().equals(targets[i].trim())){
      					 key_words[limit]=child;
      					 limit++;
      				   } 
      			   }
      			 
      			  // limit++;
      			// OWLClass Child = factory.getOWLClass((physicalURI + "#"+ targets[i].trim()));//getOWLClass(URI.create(physicalURI + "#"+ targets[i].trim()));
      			   
      			   /*Child = factory.getOWLClass(URI.create(physicalURI + "#"+ targets[i].trim()));
      			 extend_fma.CreateSubclass(Child, Parent);
      			   key_words[limit]=Child;
      			   limit++;
      			   System.out.println(targets[i]+ " is a subclass");
      			   i++;*/
      			 System.out.println(targets[i]+ " is a subclass");  
      			 i++;
      		   }
      		   //Scan the ontology for the abstracted entities
      		 for(OWLClass cls: ontology.getReferencedClasses()){
  			   if(!cls.toString().equals(Symmetry.toString()) && !cls.getSuperClasses(ontology).contains(Symmetry)){
  				   markedClasses.add(cls);
  				   System.out.println(cls);
  			   }
  		   }
	   	    
  		   for(OWLClass owlcls : markedClasses){
  			   for(OWLAxiom ax: ontology.getAxioms(owlcls)){
  				   for(OWLEntity abstracted_cls : ax.getReferencedEntities()){
  					   if(abstracted_cls instanceof OWLClass && abstracted_cls.toString().equals(Symmetry.toString())){
  						   //Create the extended subclasses under the abstracted classes 
	   	               			for(int j=0; j<limit; j++){
	   	               				search_cls = owlcls;
	   	               				replace_str = search_cls.toString().toLowerCase().replaceFirst("", key_words[j].toString() + "_");
	   	               				replace_cls = factory.getOWLClass(URI.create(physicalURI + "#" + replace_str));
	   	               				createSubclass(replace_cls, search_cls);
	   	               				
	   	               				//Add a piece for the metacarpal bones
	   	               				OWLDescription new_restr = null;
	   	               			//	if(search_cls.toString().toLowerCase().indexOf("metacarpal_bone")!=-1){
	   	               					int count_restr=0;
	   	               					for(OWLDescription d: search_cls.getSuperClasses(ontology)){
	   	               						if(d instanceof OWLObjectSomeRestriction){
	   	               							OWLObjectSomeRestriction restr = (OWLObjectSomeRestriction) d;
	   	               							
	   	               							for(OWLObjectPropertyExpression prop: restr.getProperty().getSuperProperties(ontology)){
	   	               						
	   	               								if(prop.toString().equals("has_selector"))
	   	               									count_restr++;
	   	               									if(restr.getProperty().toString().equals("has_laterality"))
	   	               										new_restr = d;
	   	               									else if(restr.getProperty().toString().equals("has_medial_lateral_selector"))
	   	               										new_restr = d;
//	   	               									else if(restr.getProperty().toString().equals("has_anterior_posterior_selector"))
//	   	               										new_restr = d;
	   	               									//set_restr.add(restr);
	   	               							}
	   	               						}
	   	               					}
	   	               					
	   	               					if(count_restr>1){
	   	               					//	hasSomeLaterality = factory.getOWLObjectSomeRestriction(new_restr.getProperty(), cls);
	   	               				//		.AddRestrictionAxiom(marked_cls, hasSomeRestriction);
	   	               						addRestrictionAxiom(replace_cls, new_restr);
	   	               						cls_remove_restr.add(search_cls);
	   	               					}
	   	               			//	}
	   	               				
	   	               				
	   	               				System.out.println(replace_cls.toString());
	   	               				abstractedClasses.add(search_cls);
	   	               				addedClasses.add(replace_cls);
	   	               			}
	   	               			remainedAxioms.add(ax);		
	   	               		} //if (abstracted_cls instanceof OWLClass ...)
  				   } //for(OWLEntity abstracted_cls : ax.getReferencedEntities())
  			   } //for(OWLAxiom ax: ontology.getAxioms(owlcls))
	   	     	} //  for(OWLClass owlcls : markedClasses)
	   	               		
	   	     	//Create the corresponding Restrictions for the entiites that
	   	     	//have been created
  		   String keyword=null;
	   	        
  		   for(OWLClass cls : addedClasses){
  			   for(int j=0; j<limit; j++){
  				   if(cls.toString().indexOf(key_words[j].toString())!= -1)
  					   keyword = key_words[j].toString(); 				
  			   }
  			  visitRestrictions(keyword, cls);
  		   } //  for(OWLClass cls : addedClasses)
      		   
      		  
  
      		   //Abstraction process
      		 //.AbstractEntities(, key_words, limit);
      		   
      		   
      	   } //else 
		   	
		} //while(i<targets.length)
		
		
		
	}
	
	

	public void createSubclass(OWLClass child, OWLClass parent) throws OWLOntologyChangeException{
		OWLAxiom axiom_subclass = factory.getOWLSubClassAxiom(child, parent);
        AddAxiom add_axiom_subclass = new AddAxiom(ontology, axiom_subclass);
        manager.applyChange(add_axiom_subclass);
	}
	
	public void createSubProperty(OWLObjectProperty child_prop, OWLObjectProperty parent_prop) throws OWLOntologyChangeException{
		OWLObjectSubPropertyAxiom subproperty_ax = 
      	  factory.getOWLSubObjectPropertyAxiom(child_prop,parent_prop); 
        AddAxiom addAx_subproperty = new AddAxiom(ontology, subproperty_ax);
        	  manager.applyChange(addAx_subproperty);
	}
	
	public void defineRange(OWLObjectProperty property, OWLClass range) throws OWLOntologyChangeException{
		OWLObjectPropertyRangeAxiom obj_range= 
        		  factory.getOWLObjectPropertyRangeAxiom(property, range);
		AddAxiom addax_property_range = new AddAxiom(ontology, obj_range);
		manager.applyChange(addax_property_range);
	}
	
	public void defineFunctionalCharacteristic(OWLObjectProperty property) throws OWLOntologyChangeException{
		OWLFunctionalObjectPropertyAxiom functional_prop 
  	  		= factory.getOWLFunctionalObjectPropertyAxiom(property);
  	  	AddAxiom addax_property_func = new AddAxiom(ontology, functional_prop);
  	  	manager.applyChange(addax_property_func); 
	}
	

	public void addRestrictionAxiom(OWLClass owlclasss, OWLDescription restriction) throws OWLOntologyChangeException{
		OWLSubClassAxiom axiom = factory.getOWLSubClassAxiom(owlclasss, restriction);
       	// Add the axiom to our ontology
       	AddAxiom add_axiom = new AddAxiom(ontology, axiom);
       	manager.applyChange(add_axiom);
	}
	

	public void saveOntology()throws OWLOntologyStorageException{
		//Mac OS path
		URI physicalURI2 = URI.create("file:" + outputFolderName + "Extended_Ontology_v0_6.owl");
		//URI physicalURI2 = URI.create("file:/" + outputFolderName.replace('\\', '/') + "Extended_Ontology_v0_6.owl");
        manager.saveOntology(ontology, physicalURI2);
        manager.removeOntology(ontology.getURI());
	}
	
	
    public void visitRestrictions(String keyword, OWLClass marked_cls) throws OWLOntologyChangeException {
        // This method gets called when a description (OWLDescription) is an
        // existential (someValuesFrom) restriction and it asks us to visit it
    	String replace_str;
    	OWLObjectSomeRestriction hasSomeRestriction;
    	Object[] parent;
    	OWLClass parent_cls;
    	OWLObjectSomeRestriction restriction;
    	OWLClass restr_cls;
    	
    	parent = marked_cls.getSuperClasses(ontology).toArray();
    	parent_cls = (OWLClass) parent[0];
    	
    	for(OWLDescription desc : parent_cls.getSuperClasses(ontology)){
    		if(desc instanceof OWLObjectSomeRestriction){
    			restriction = (OWLObjectSomeRestriction) desc;
    			if(restriction.getFiller() instanceof OWLClass && !restriction.getFiller().isAnonymous()){
    				restr_cls = (OWLClass) restriction.getFiller();
    				
    				
    				
    				//REplace the name and search the ontology. If it exist create the restriction
    				replace_str = restr_cls.toString().toLowerCase().replaceFirst("", keyword + "_");
    			
    				for(OWLClass cls : ontology.getReferencedClasses()){
    					if(cls.toString().equals(replace_str)){
    						hasSomeRestriction = factory.getOWLObjectSomeRestriction(restriction.getProperty(), cls);
                       		addRestrictionAxiom(marked_cls, hasSomeRestriction);
    					}
    				}	
    			}
    		}
    			System.out.println(desc.toString());
    	}       
    }
   
    
    public OWLClass searchOntology(OWLClass search_cls){
    	OWLClass result_cls = null;
    	for(OWLClass cl : ontology.getReferencedClasses()){
    		if(cl.toString().equals(search_cls)){
    			result_cls= cl;
    		}
    	}
    	return result_cls;
    }
	
	public void startExtensionAlgorithm(){
		
		OWLEntityRemover remover = null;
		
		
		//Load the file with the target hierarchy 
		
		
		try{	
		//1. Load the ontology that is defined in the args[0]
			
			
		//	String base=args[0];
	//		Extend = new Extend(base, targets);
		//	OWLClass[] key_words= new OWLClass[10];
			
			//2. Find the Refining hierarchy
			for(OWLClass owlcls : ontology.getReferencedClasses()){
				if(owlcls.toString().equals("Refining_entity"))
					Refining_entity=owlcls;
				if(owlcls.toString().equals("Selector"))
					Selector = owlcls;
			} //for(OWLClass owlcls : ontology.getReferencedClasses())
			
			
			remover = new OWLEntityRemover(manager, Collections.singleton(ontology));
			
			//Take the hierarchy under the Selector and make the extension
			doTheExtension(ontologyFilename);
			
					
			OWLEntityRemover remove_cls = new OWLEntityRemover(manager, Collections.singleton(ontology));
			for(OWLClass c: cls_remove_restr){
				for (OWLDescription des : c.getSubClasses(ontology)){
					if(des instanceof OWLClass){
						OWLClass cl = (OWLClass) des;
						if(cl.toString().indexOf("Left_")!=-1 || cl.toString().indexOf("Right")!=-1){
							cl.accept(remove_cls);
						}
					}
				}
			}
			for(OWLDescription remcls : Refining_entity.getSubClasses(ontology)){
				OWLClass c;
				c = (OWLClass) remcls;
				//c.accept(remove_cls);
				remove_cls.visit(c);
			}
			for(OWLDescription des : Selector.getSubClasses(ontology)){
				OWLClass cdes;
				cdes = (OWLClass) des;
				remove_cls.visit(cdes);
			}
			manager.applyChanges(remove_cls.getChanges());
	   	    remove_cls.reset();
			
			for(OWLObjectProperty prop : ontology.getReferencedObjectProperties()){
				if(prop.toString().equals("has_selector")){
					hasSelector = prop;
				}
			}
			for(OWLPropertyExpression objd : hasSelector.getSubProperties(ontology)){
				remove_cls.visit((OWLObjectProperty) objd);
				//objd.accept((OWLPropertyExpressionVisitor) remove_cls);
			}
			Refining_entity.accept(remove_cls);
			manager.applyChanges(remove_cls.getChanges());
	   	    remove_cls.reset();
			
			//save the ontology  
			saveOntology();
		}
		catch (Exception e) {
           e.printStackTrace();
       }
	} //main
	

}
